$(document).ready(function() {


	stopAnimation();

	navOnClick();

	
});//Ready

//Variables Definition

var navItems = $('ul.nav li'); //The items which show slider animation status
			
var msgHolder = $('ul.message');//Ul which contains the messages list

var imageHolder = $('ul.image-holder');//Ul which contains the list items with images

var liQuantity = $('ul.image-holder li').length; //Quantity of all the items to be animated for each group 

//I chose the image holder quantity but i could take navItems or messages quantity.

var liHeight = $('ul.image-holder li').height(); //Images height is stored 

var liHeightMsg = $('ul.message li').height();	//Messages height is saved	

var i = 1; //i represents a index of navItems, it is initialized on 1 because the animation starts moving 

//the second item on the list.

var direction = true; //It tells in which direction the animation goes. True represent a way and false its opposite.

var navStatus = true; //This variable is set as a switcher, because the clearInterval 

//function is used to stop a Javascript based animation when the user looses 

//focus on the current window, but in order to stop that animation  definitely, this variable is set to false.

//The following variables are set null in order to store values afterwards

var imgSlider = null; //It stores the setInterval function which creates a Javascript based animation

//on browsers which does not support CSS3 animations

var prevIndex = null; //This variable checks if a same navItem is clicked twice.

//stopAnimation aims to stop the animation when the user looses focus
//the current Window.

function stopAnimation() {

	//First it is tested if the browser supports css animations

	if(Modernizr.cssanimations){

		//If the test outcome is true we set  two functions: 

		//First when user looses focus on current window we stop the CSS3 Animation using 
		//animation-play-state paused


		//Since some browsers only accept vendor prefixes and do not 
		//"read" the regular property we should prepare both posibilities 
		//we could face conflicts in the console.
		$(window).blur(function(){

			$(navItems).css("animation-play-state","paused"); 
			$(navItems).css("-webkit-animation-play-state","paused");
			$(msgHolder).css("animation-play-state","paused"); 
			$(msgHolder).css("-webkit-animation-play-state","paused");
			$(imageHolder).css("animation-play-state","paused"); 
			$(imageHolder).css("-webkit-animation-play-state","paused");
	
		})//Window

		//When the user recovers focus on current window the CSS3 Animation resumes

		$(window).focus(function(){
			
			$(navItems).css("animation-play-state","running"); 
			$(navItems).css("-webkit-animation-play-state","running");
			$(msgHolder).css("animation-play-state","running"); 
			$(msgHolder).css("-webkit-animation-play-state","running");
			$(imageHolder).css("animation-play-state","running"); 
			$(imageHolder).css("-webkit-animation-play-state","running");
	

		})//Window

	} else{


			//Animation for Browsers which do not support CSS3 Animations

			//Animation function has internally a setInterval function
			//in order to simulate the CSS3 Animation on browsers which do not support
			//that feature natively
			function animation() {

			$(window).focus(function(){
						imgSlider = setInterval(
						function() {
							//we test if the navStatus is true, so the animation 
							//can continue.
							if(navStatus == true) {	
									//Direction is tested in order to know where the animation
									//is headed to, e.g. for images and messages if they go 	
									//from from bottom to top or the other way around.
									//Regarding navItems, direction let us know if the animation 
									//can go from left to right or vice versa.
									if(direction == true) {
										if(i < liQuantity) {
								                $(imageHolder).animate({
								                    top: "-=" + liHeight+"px"
								                	}, 4000);

								                $(msgHolder).animate({
								                    top: "-=" + liHeightMsg+"px"
								                	}, 4000);

								                navItems.removeClass("selected");
								                navItems.eq(i).addClass("selected", 1000);

							                i++;

								        } else {

								        	direction = false;
								        	
								        	i = liQuantity - 2;

								        };

									} else {
											
										 if(i > 0){
				 

										 	$(imageHolder).animate({
								                top: "+=" + liHeight+"px"
								               	}, 4000);

								            $(msgHolder).animate({
								                top: "+=" + liHeightMsg+"px"
								              	}, 4000);

								            navItems.removeClass("selected");
								            navItems.eq(i).addClass("selected", 1000);

								            i--;

										} else {
											
										
											$(imageHolder).animate({
								                top: "+=" + liHeight+"px"
								               	}, 4000);

								            $(msgHolder).animate({
								                top: "+=" + liHeightMsg+"px"
								              	}, 4000);

										
											navItems.removeClass("selected");
											navItems.eq(i).addClass("selected", 1000);
											direction = true;
											i = 1;


										};
										
									};

								   };
								}//function imageSlider
						, 4000);


				});//focus

				$(window).blur(function(){


					clearInterval(imgSlider);

				});//blur

		};//Animation

		animation();

	};

};//stopAnimation


//navOnClick  stops any animation on the slider (both CSS3 o Javascript)
//so from the moment that the user clicks on the navigation menu
//at the bottom, he or she can go to any image and sentence of the slider manually. 
function navOnClick(){
    
    $(navItems).on("click", function(){
        
        //Clicked item is captured in a variable
        var $this = $(this);


        //Then its index is stored in a variable
        var $thisIndex = navItems.index($this);

        //Class named "selected" is removed from the nav items
       	navItems.removeClass("selected");

       	//Class "selected" is place on the item which is clicked by user
		navItems.eq($thisIndex).addClass("selected");

		//This comparison is done in order to avoid triggering a animation several times on
		//a selected item, because it generates a delay when you want to select another
		//item on the menu
		if(prevIndex == $thisIndex) {
		
			return false;

		} else {

		    //prevIndex takes the same index value of the current selected index
		    //so in the following selection if the same item is selected, 
		    //the function will be stopped by return false.      
		    prevIndex = $thisIndex;

		    //As the behavior of stopping an animation change if the browser 
		    //supports CSS3 Animations or not, we use Modernizr to check browser capabilities
		  	if(Modernizr.cssanimations){

		  		//On browser with support, setting animation none to stop animation forever.
				$(navItems).css("animation", "none");
				$(imageHolder).css("animation", "none").animate({top: "-"+$thisIndex*liHeight+"px"}, 4000);
				$(msgHolder).css("animation", "none").animate({top: "-"+$thisIndex*liHeightMsg+"px"}, 4000);

			}else{

				//As we had used clearInterval to stop Javascript animation when user looses focus on
				//the current window, we change the animation status to false in order to stop it.
				navStatus = false;

				$(imageHolder).animate({top: "-"+$thisIndex*liHeight+"px"}, 4000);
				$(msgHolder).animate({top: "-"+$thisIndex*liHeightMsg+"px"}, 4000);

			};//Modernizr test

		};	

    
    });//Click

};//navOnClick